action.yml 7.4 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205
  1. # NOTE: Do not rely on `make` commands here as this action is used across different repos
  2. # where the Makefile will not be available
  3. name: 'Sentry Setup'
  4. description: 'Sets up a Sentry test environment'
  5. inputs:
  6. workdir:
  7. description: 'Directory where the sentry source is located'
  8. required: false
  9. default: '.'
  10. snuba:
  11. description: 'Is snuba required?'
  12. required: false
  13. default: 'false'
  14. clickhouse:
  15. description: 'Is clickhouse required?'
  16. required: false
  17. default: 'false'
  18. kafka:
  19. description: 'Is kafka required?'
  20. required: false
  21. default: 'false'
  22. chartcuterie:
  23. description: 'Is chartcuterie required?'
  24. required: false
  25. default: 'false'
  26. bigtable:
  27. description: 'Is bigtable required?'
  28. required: false
  29. default: 'false'
  30. redis_cluster:
  31. description: 'Is redis cluster required?'
  32. required: false
  33. default: 'false'
  34. symbolicator:
  35. description: 'Is symbolicator required?'
  36. required: false
  37. default: 'false'
  38. peanutbutter:
  39. description: 'Is peanutbutter required?'
  40. required: false
  41. default: 'false'
  42. python-version:
  43. description: 'python version to install'
  44. required: false
  45. default: '3.11.8'
  46. pg-version:
  47. description: 'PostgreSQL version to use'
  48. default: '14'
  49. required: false
  50. outputs:
  51. yarn-cache-dir:
  52. description: 'Path to yarn cache'
  53. value: ${{ steps.config.outputs.yarn-cache-dir }}
  54. matrix-instance-number:
  55. description: 'The matrix instance number (starting at 1)'
  56. value: ${{ steps.config.outputs.matrix-instance-number }}
  57. matrix-instance-total:
  58. description: 'Reexport of MATRIX_INSTANCE_TOTAL.'
  59. value: ${{ steps.config.outputs.matrix-instance-total }}
  60. runs:
  61. using: 'composite'
  62. steps:
  63. - name: Setup default environment variables
  64. # the default for "bash" is:
  65. # bash --noprofile --norc -eo pipefail {0}
  66. shell: bash --noprofile --norc -eo pipefail -ux {0}
  67. env:
  68. MATRIX_INSTANCE: ${{ matrix.instance }}
  69. # XXX: We should be using something like len(strategy.matrix.instance) (not possible atm)
  70. # If you have other things like python-version: [foo, bar, baz] then the sharding logic
  71. # isn't right because job-total will be 3x larger and you'd never run 2/3 of the tests.
  72. # MATRIX_INSTANCE_TOTAL: ${{ strategy.job-total }}
  73. run: |
  74. echo "PIP_DISABLE_PIP_VERSION_CHECK=on" >> $GITHUB_ENV
  75. echo "PIP_INDEX_URL=https://pypi.devinfra.sentry.io/simple" >> $GITHUB_ENV
  76. echo "SENTRY_SKIP_BACKEND_VALIDATION=1" >> $GITHUB_ENV
  77. ### node configuration ###
  78. echo "NODE_ENV=development" >> $GITHUB_ENV
  79. ### pytest configuration ###
  80. echo "PY_COLORS=1" >> "$GITHUB_ENV"
  81. echo "PYTEST_ADDOPTS=--reruns=5 --durations=10 --fail-slow=60s" >> $GITHUB_ENV
  82. ### pytest-sentry configuration ###
  83. if [ "$GITHUB_REPOSITORY" = "getsentry/sentry" ]; then
  84. echo "PYTEST_SENTRY_DSN=https://6fd5cfea2d4d46b182ad214ac7810508@sentry.io/2423079" >> $GITHUB_ENV
  85. echo "PYTEST_SENTRY_TRACES_SAMPLE_RATE=0" >> $GITHUB_ENV
  86. # This records failures on master to sentry in order to detect flakey tests, as it's
  87. # expected that people have failing tests on their PRs
  88. if [ "$GITHUB_REF" = "refs/heads/master" ]; then
  89. echo "PYTEST_SENTRY_ALWAYS_REPORT=1" >> $GITHUB_ENV
  90. fi
  91. fi
  92. # Configure a different release version, otherwise it defaults to the
  93. # commit sha which will conflict with our actual prod releases. This is a
  94. # confusing experience because it looks like these are "empty" releases
  95. # because no commits are attached and associates the release with our
  96. # javascript + sentry projects.
  97. echo "SENTRY_RELEASE=ci@$GITHUB_SHA" >> $GITHUB_ENV
  98. # this handles pytest test sharding
  99. if [ "$MATRIX_INSTANCE" ]; then
  100. if ! [ "${MATRIX_INSTANCE_TOTAL:-}" ]; then
  101. echo "MATRIX_INSTANCE_TOTAL is required."
  102. exit 1
  103. fi
  104. echo "TEST_GROUP=$MATRIX_INSTANCE" >> $GITHUB_ENV
  105. echo "TOTAL_TEST_GROUPS=$MATRIX_INSTANCE_TOTAL" >> $GITHUB_ENV
  106. fi
  107. - uses: getsentry/action-setup-venv@a133e6fd5fa6abd3f590a1c106abda344f5df69f # v2.1.0
  108. with:
  109. python-version: ${{ inputs.python-version }}
  110. cache-dependency-path: ${{ inputs.workdir }}/requirements-dev-frozen.txt
  111. install-cmd: cd ${{ inputs.workdir }} && python3 -m tools.hack_pip && pip install -r requirements-dev-frozen.txt
  112. - name: Set up outputs
  113. id: config
  114. env:
  115. MATRIX_INSTANCE: ${{ matrix.instance }}
  116. shell: bash --noprofile --norc -eo pipefail -ux {0}
  117. run: |
  118. echo "yarn-cache-dir=$(yarn cache dir)" >> "$GITHUB_OUTPUT"
  119. echo "matrix-instance-number=$(($MATRIX_INSTANCE+1))" >> "$GITHUB_OUTPUT"
  120. echo "matrix-instance-total=$((${MATRIX_INSTANCE_TOTAL:-}))" >> "$GITHUB_OUTPUT"
  121. - name: Install python dependencies
  122. shell: bash --noprofile --norc -eo pipefail -ux {0}
  123. env:
  124. # This is necessary when other repositories (e.g. relay) want to take advantage of this workflow
  125. # without needing to fork it. The path needed is the one where setup.py is located
  126. WORKDIR: ${{ inputs.workdir }}
  127. run: |
  128. cd "$WORKDIR"
  129. # We need to install editable otherwise things like check migration will fail.
  130. python3 -m tools.fast_editable --path .
  131. - name: Start devservices
  132. shell: bash --noprofile --norc -eo pipefail -ux {0}
  133. env:
  134. NEED_KAFKA: ${{ inputs.kafka }}
  135. NEED_SNUBA: ${{ inputs.snuba }}
  136. NEED_CLICKHOUSE: ${{ inputs.clickhouse }}
  137. NEED_BIGTABLE: ${{ inputs.bigtable }}
  138. NEED_CHARTCUTERIE: ${{ inputs.chartcuterie }}
  139. NEED_REDIS_CLUSTER: ${{ inputs.redis_cluster }}
  140. NEED_SYMBOLICATOR: ${{ inputs.symbolicator }}
  141. NEED_PEANUTBUTTER: ${{ inputs.peanutbutter }}
  142. WORKDIR: ${{ inputs.workdir }}
  143. PG_VERSION: ${{ inputs.pg-version }}
  144. ENABLE_AUTORUN_MIGRATION_SEARCH_ISSUES: '1'
  145. run: |
  146. sentry init
  147. # redis, postgres are needed for almost every code path.
  148. services=(redis postgres)
  149. if [ "$NEED_CLICKHOUSE" = "true" ] || [ "$NEED_SNUBA" = "true" ]; then
  150. services+=(clickhouse)
  151. fi
  152. if [ "$NEED_SNUBA" = "true" ]; then
  153. services+=(snuba)
  154. fi
  155. if [ "$NEED_BIGTABLE" = "true" ]; then
  156. echo "BIGTABLE_EMULATOR_HOST=127.0.0.1:8086" >> $GITHUB_ENV
  157. services+=(bigtable)
  158. fi
  159. if [ "$NEED_CHARTCUTERIE" = "true" ]; then
  160. services+=(chartcuterie)
  161. fi
  162. if [ "$NEED_REDIS_CLUSTER" = "true" ]; then
  163. services+=(redis-cluster)
  164. fi
  165. if [ "$NEED_SYMBOLICATOR" = "true" ]; then
  166. services+=(symbolicator)
  167. fi
  168. if [ "$NEED_PEANUTBUTTER" = "true" ]; then
  169. services+=(peanutbutter)
  170. fi
  171. if [ "$NEED_KAFKA" = "true" ]; then
  172. services+=(kafka)
  173. fi
  174. sentry devservices up "${services[@]}"
  175. # have tests listen on the docker gateway ip so loopback can occur
  176. echo "DJANGO_LIVE_TEST_SERVER_ADDRESS=$(docker network inspect bridge --format='{{(index .IPAM.Config 0).Gateway}}')" >> "$GITHUB_ENV"
  177. docker ps -a
  178. # This is necessary when other repositories (e.g. relay) want to take advantage of this workflow
  179. # without needing to fork it. The path needed is the one where tools are located
  180. cd "$WORKDIR"